Index: .bzrignore
===================================================================
--- .bzrignore	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ .bzrignore	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -1,30 +1,55 @@
 *.disasm
+*.la
+*.lo
 *.map
 *.prev
-*.ag.probe.[cs]
-*.lo
-*.la
 *.so.*
-Makefile.depend
 Makefile.ag.depend
 Makefile.common
 Makefile.config
-cscope.out
+Makefile.depend
 autotool/
+boot/distroot/
+boot/initrd.img
 common.h
 config.h
+cscope.out
 hdisk.img
 image.iso
-boot/distroot/
-boot/initrd.img
+kernel/arch/amd64/_link.ld
+kernel/arch/amd64/include/arch/boot/memmap_struct.h
+kernel/arch/amd64/include/arch/common.h
+kernel/arch/amd64/include/arch/context_struct.h
+kernel/arch/amd64/include/arch/istate_struct.h
+kernel/arch/amd64/include/arch/kseg_struct.h
+kernel/arch/arm32/_link.ld
+kernel/arch/arm32/include/arch/context_struct.h
+kernel/arch/arm32/include/arch/istate_struct.h
+kernel/arch/ia32/_link.ld
+kernel/arch/ia32/include/arch/boot/memmap_struct.h
+kernel/arch/ia32/include/arch/context_struct.h
+kernel/arch/ia32/include/arch/istate_struct.h
+kernel/arch/ia64/include/arch/context_struct.h
+kernel/arch/ia64/include/arch/istate_struct.h
+kernel/arch/mips32/include/arch/context_struct.h
+kernel/arch/mips32/include/arch/fpu_context_struct.h
+kernel/arch/mips32/include/arch/istate_struct.h
+kernel/arch/ppc32/include/arch/context_struct.h
+kernel/arch/ppc32/include/arch/fpu_context_struct.h
+kernel/arch/ppc32/include/arch/istate_struct.h
+kernel/arch/sparc64/include/arch/context_struct.h
+kernel/arch/sparc64/include/arch/istate_struct.h
+kernel/genarch/include/genarch/multiboot/multiboot_info_struct.h
+kernel/genarch/include/genarch/multiboot/multiboot_memmap_struct.h
+kernel/generic/src/debug/real_map.bin
 kernel/kernel.bin
 kernel/kernel.dump
 kernel/kernel.raw
-kernel/arch/amd64/_link.ld
-kernel/arch/amd64/include/arch/common.h
-kernel/generic/src/debug/real_map.bin
 uspace/app/barber/barber
 uspace/app/barber/images.c
 uspace/app/barber/images.h
+uspace/app/barber/images.s
+uspace/app/barber/images.zip
+uspace/app/barber/images_desc.c
 uspace/app/bdsh/bdsh
 uspace/app/bdsh/test-bdsh
@@ -32,15 +57,18 @@
 uspace/app/blkdump/blkdump
 uspace/app/bnchmark/bnchmark
-uspace/drv/char/pl050/pl050
+uspace/app/corecfg/corecfg
 uspace/app/date/date
 uspace/app/devctl/devctl
+uspace/app/df/df
 uspace/app/dltest/dltest
 uspace/app/dltests/dltests
 uspace/app/dnscfg/dnscfg
 uspace/app/dnsres/dnsres
+uspace/app/download/download
 uspace/app/edit/edit
 uspace/app/fdisk/fdisk
 uspace/app/fontviewer/fontviewer
 uspace/app/getterm/getterm
+uspace/app/gunzip/gunzip
 uspace/app/inet/inet
 uspace/app/init/init
@@ -57,12 +85,13 @@
 uspace/app/modplay/modplay
 uspace/app/netecho/netecho
+uspace/app/netspeed/netspeed
 uspace/app/nettest1/nettest1
 uspace/app/nettest2/nettest2
 uspace/app/nettest3/nettest3
 uspace/app/nic/nic
-uspace/app/netecho/netecho
 uspace/app/nterm/nterm
 uspace/app/ping/ping
 uspace/app/ping6/ping6
+uspace/app/pkg/pkg
 uspace/app/rcubench/rcubench
 uspace/app/rcutest/rcutest
@@ -80,9 +109,14 @@
 uspace/app/top/top
 uspace/app/trace/trace
+uspace/app/untar/untar
 uspace/app/usbinfo/usbinfo
 uspace/app/vcalc/vcalc
 uspace/app/vdemo/vdemo
+uspace/app/viewer/viewer
 uspace/app/vlaunch/images.c
 uspace/app/vlaunch/images.h
+uspace/app/vlaunch/images.s
+uspace/app/vlaunch/images.zip
+uspace/app/vlaunch/images_desc.c
 uspace/app/vlaunch/vlaunch
 uspace/app/vterm/vterm
@@ -96,14 +130,18 @@
 uspace/dist/app/blkdump
 uspace/dist/app/bnchmark
+uspace/dist/app/corecfg
 uspace/dist/app/date
 uspace/dist/app/devctl
+uspace/dist/app/df
 uspace/dist/app/dltest
 uspace/dist/app/dltests
 uspace/dist/app/dnscfg
 uspace/dist/app/dnsres
+uspace/dist/app/download
 uspace/dist/app/edit
 uspace/dist/app/fdisk
 uspace/dist/app/fontviewer
 uspace/dist/app/getterm
+uspace/dist/app/gunzip
 uspace/dist/app/inet
 uspace/dist/app/kill
@@ -119,12 +157,13 @@
 uspace/dist/app/modplay
 uspace/dist/app/netecho
+uspace/dist/app/netspeed
 uspace/dist/app/nettest1
 uspace/dist/app/nettest2
 uspace/dist/app/nettest3
 uspace/dist/app/nic
-uspace/dist/app/netecho
 uspace/dist/app/nterm
 uspace/dist/app/ping
 uspace/dist/app/ping6
+uspace/dist/app/pkg
 uspace/dist/app/rcubench
 uspace/dist/app/rcutest
@@ -142,7 +181,9 @@
 uspace/dist/app/top
 uspace/dist/app/trace
+uspace/dist/app/untar
 uspace/dist/app/usbinfo
 uspace/dist/app/vcalc
 uspace/dist/app/vdemo
+uspace/dist/app/viewer
 uspace/dist/app/vlaunch
 uspace/dist/app/vterm
@@ -151,7 +192,11 @@
 uspace/dist/app/websrv
 uspace/dist/app/wifi_supplicant
+uspace/dist/demo.txt
+uspace/dist/demo.wav
+uspace/dist/demo.xm
 uspace/dist/drv/ahci/
 uspace/dist/drv/ar9271/
 uspace/dist/drv/ata_bd/
+uspace/dist/drv/atkbd/
 uspace/dist/drv/cmos-rtc/
 uspace/dist/drv/e1k/
@@ -159,4 +204,6 @@
 uspace/dist/drv/hdaudio/
 uspace/dist/drv/i8042/
+uspace/dist/drv/icp/
+uspace/dist/drv/icp-ic/
 uspace/dist/drv/isa/
 uspace/dist/drv/kfb/
@@ -166,8 +213,8 @@
 uspace/dist/drv/pc/
 uspace/dist/drv/pciintel/
+uspace/dist/drv/pl050/
 uspace/dist/drv/ps2mouse/
 uspace/dist/drv/root/
 uspace/dist/drv/rootpc/
-uspace/dist/drv/virt/
 uspace/dist/drv/rtl8139/
 uspace/dist/drv/rtl8169/
@@ -183,7 +230,10 @@
 uspace/dist/drv/usbmid/
 uspace/dist/drv/vhc/
+uspace/dist/drv/virt/
 uspace/dist/drv/xtkbd/
-uspace/dist/drv/atkbd/
 uspace/dist/drv/xhci/
+uspace/dist/inc/_link.ld
+uspace/dist/inc/c/
+uspace/dist/logo.tga
 uspace/dist/srv/apic
 uspace/dist/srv/cdfs
@@ -192,4 +242,5 @@
 uspace/dist/srv/console
 uspace/dist/srv/devman
+uspace/dist/srv/dhcp
 uspace/dist/srv/dnsrsrv
 uspace/dist/srv/ethip
@@ -203,9 +254,12 @@
 uspace/dist/srv/input
 uspace/dist/srv/isdv4_tablet
+uspace/dist/srv/klog
 uspace/dist/srv/locfs
 uspace/dist/srv/loopip
 uspace/dist/srv/mfs
+uspace/dist/srv/nconfsrv
 uspace/dist/srv/output
 uspace/dist/srv/remcons
+uspace/dist/srv/rfb
 uspace/dist/srv/sata_bd
 uspace/dist/srv/slip
@@ -223,4 +277,5 @@
 uspace/drv/block/ata_bd/ata_bd
 uspace/drv/block/ddisk/ddisk
+uspace/drv/bus/adb/cuda_adb/cuda_adb
 uspace/drv/bus/isa/isa
 uspace/drv/bus/pci/pciintel/pciintel
@@ -236,15 +291,13 @@
 uspace/drv/bus/usb/xhci/xhci
 uspace/drv/bus/usb/xhci/test-xhci
+uspace/drv/char/atkbd/atkbd
 uspace/drv/char/i8042/i8042
 uspace/drv/char/ns8250/ns8250
+uspace/drv/char/pl050/pl050
 uspace/drv/char/ps2mouse/ps2mouse
 uspace/drv/char/xtkbd/xtkbd
-uspace/drv/char/atkbd/atkbd
+uspace/drv/fb/amdm37x_dispc/amdm37x_dispc
 uspace/drv/fb/kfb/kfb
-uspace/drv/root/root/root
-uspace/drv/root/virt/virt
-uspace/drv/platform/icp/icp
-uspace/drv/platform/pc/pc
-uspace/drv/platform/rootpc/rootpc
+uspace/drv/intctl/icp-ic/icp-ic
 uspace/drv/nic/ar9271/ar9271
 uspace/drv/nic/e1k/e1k
@@ -252,4 +305,13 @@
 uspace/drv/nic/rtl8139/rtl8139
 uspace/drv/nic/rtl8169/rtl8169
+uspace/drv/platform/amdm37x/amdm37x
+uspace/drv/platform/icp/icp
+uspace/drv/platform/mac/mac
+uspace/drv/platform/malta/malta
+uspace/drv/platform/msim/msim
+uspace/drv/platform/pc/pc
+uspace/drv/platform/rootpc/rootpc
+uspace/drv/root/root/root
+uspace/drv/root/virt/virt
 uspace/drv/test/test1/test1
 uspace/drv/test/test2/test2
@@ -261,10 +323,37 @@
 uspace/lib/c/arch/amd64/_link.ld
 uspace/lib/c/arch/amd64/include/libarch/common.h
+uspace/lib/c/arch/amd64/include/libarch/fibril_context.h
+uspace/lib/c/arch/amd64/include/libarch/istate_struct.h
+uspace/lib/c/arch/arm32/_link-dlexe.ld
+uspace/lib/c/arch/arm32/_link-loader.ld
+uspace/lib/c/arch/arm32/_link-shlib.ld
+uspace/lib/c/arch/arm32/_link.ld
+uspace/lib/c/arch/arm32/include/libarch/fibril_context.h
+uspace/lib/c/arch/arm32/include/libarch/istate_struct.h
+uspace/lib/c/arch/ia32/_link-dlexe.ld
+uspace/lib/c/arch/ia32/_link-loader.ld
+uspace/lib/c/arch/ia32/_link-shlib.ld
+uspace/lib/c/arch/ia32/_link.ld
+uspace/lib/c/arch/ia32/include/libarch/fibril_context.h
+uspace/lib/c/arch/ia32/include/libarch/istate_struct.h
+uspace/lib/c/arch/ia64/include/libarch/fibril_context.h
+uspace/lib/c/arch/ia64/include/libarch/istate_struct.h
+uspace/lib/c/arch/mips32/include/libarch/fibril_context.h
+uspace/lib/c/arch/mips32/include/libarch/istate_struct.h
+uspace/lib/c/arch/mips32eb/include/libarch/fibril_context.h
+uspace/lib/c/arch/mips32eb/include/libarch/istate_struct.h
+uspace/lib/c/arch/ppc32/include/libarch/fibril_context.h
+uspace/lib/c/arch/ppc32/include/libarch/istate_struct.h
+uspace/lib/c/arch/sparc64/include/libarch/fibril_context.h
+uspace/lib/c/arch/sparc64/include/libarch/istate_struct.h
 uspace/lib/c/test-libc
+uspace/lib/label/test-liblabel
 uspace/lib/pcut/test-libpcut-*
 uspace/lib/posix/collisions.list
+uspace/lib/posix/include/libc
+uspace/lib/posix/redefs-hide-libc-symbols.list
 uspace/lib/posix/redefs-hide-libc.xargs
+uspace/lib/posix/redefs-show-posix-symbols.list
 uspace/lib/posix/redefs-show-posix.xargs
-uspace/lib/posix/include/libc
 uspace/lib/posix/test-libposix
 uspace/lib/uri/test-liburi
@@ -292,83 +381,27 @@
 uspace/srv/hid/output/output
 uspace/srv/hid/remcons/remcons
+uspace/srv/hid/rfb/rfb
 uspace/srv/hid/s3c24xx_ts/s3c24xx_ts
+uspace/srv/hw/bus/cuda_adb/cuda_adb
 uspace/srv/hw/char/s3c24xx_uart/s3c24ser
 uspace/srv/hw/irc/apic/apic
 uspace/srv/hw/irc/i8259/i8259
+uspace/srv/hw/irc/obio/obio
+uspace/srv/klog/klog
 uspace/srv/loader/loader
 uspace/srv/locsrv/locsrv
 uspace/srv/logger/logger
+uspace/srv/net/dhcp/dhcp
 uspace/srv/net/dnsrsrv/dnsrsrv
 uspace/srv/net/ethip/ethip
 uspace/srv/net/inetsrv/inetsrv
 uspace/srv/net/loopip/loopip
+uspace/srv/net/nconfsrv/nconfsrv
 uspace/srv/net/slip/slip
 uspace/srv/net/tcp/tcp
+uspace/srv/net/tcp/test-tcp
 uspace/srv/net/udp/udp
 uspace/srv/ns/ns
 uspace/srv/taskmon/taskmon
+uspace/srv/vfs/vfs
 uspace/srv/volsrv/volsrv
-uspace/srv/vfs/vfs
-kernel/arch/ia32/_link.ld
-uspace/lib/c/arch/ia32/_link-dlexe.ld
-uspace/lib/c/arch/ia32/_link-loader.ld
-uspace/lib/c/arch/ia32/_link-shlib.ld
-uspace/lib/c/arch/ia32/_link.ld
-kernel/arch/arm32/_link.ld
-uspace/app/corecfg/corecfg
-uspace/dist/app/corecfg
-uspace/dist/srv/rfb
-uspace/srv/hid/rfb/rfb
-uspace/dist/srv/dhcp
-uspace/srv/net/dhcp/dhcp
-uspace/dist/srv/nconfsrv
-uspace/srv/net/nconfsrv/nconfsrv
-uspace/app/netspeed/netspeed
-uspace/dist/app/netspeed
-uspace/app/df/df
-uspace/dist/app/df
-uspace/app/download/download
-uspace/dist/app/download
-uspace/app/viewer/viewer
-uspace/dist/app/viewer
-uspace/app/untar/untar
-uspace/dist/app/untar
-uspace/lib/posix/redefs-hide-libc-symbols.list
-uspace/lib/posix/redefs-show-posix-symbols.list
-uspace/srv/klog/klog
-uspace/dist/srv/klog
-kernel/arch/sparc64/include/arch/context_struct.h
-kernel/arch/sparc64/include/arch/istate_struct.h
-kernel/arch/amd64/include/arch/context_struct.h
-kernel/arch/amd64/include/arch/istate_struct.h
-kernel/arch/ia32/include/arch/context_struct.h
-kernel/arch/ia32/include/arch/istate_struct.h
-kernel/arch/ia32/include/arch/boot/memmap_struct.h
-kernel/arch/ppc32/include/arch/context_struct.h
-kernel/arch/ppc32/include/arch/fpu_context_struct.h
-kernel/arch/ppc32/include/arch/istate_struct.h
-kernel/arch/arm32/include/arch/context_struct.h
-kernel/arch/arm32/include/arch/istate_struct.h
-kernel/arch/mips32/include/arch/context_struct.h
-kernel/arch/mips32/include/arch/fpu_context_struct.h
-kernel/arch/mips32/include/arch/istate_struct.h
-kernel/arch/ia64/include/arch/context_struct.h
-kernel/arch/ia64/include/arch/istate_struct.h
-kernel/genarch/include/genarch/multiboot/multiboot_info_struct.h
-kernel/genarch/include/genarch/multiboot/multiboot_memmap_struct.h
-uspace/lib/c/arch/sparc64/include/libarch/fibril_context.h
-uspace/lib/c/arch/sparc64/include/libarch/istate_struct.h
-uspace/lib/c/arch/amd64/include/libarch/fibril_context.h
-uspace/lib/c/arch/amd64/include/libarch/istate_struct.h
-uspace/lib/c/arch/ia32/include/libarch/fibril_context.h
-uspace/lib/c/arch/ia32/include/libarch/istate_struct.h
-uspace/lib/c/arch/ppc32/include/libarch/fibril_context.h
-uspace/lib/c/arch/ppc32/include/libarch/istate_struct.h
-uspace/lib/c/arch/arm32/include/libarch/fibril_context.h
-uspace/lib/c/arch/arm32/include/libarch/istate_struct.h
-uspace/lib/c/arch/mips32eb/include/libarch/fibril_context.h
-uspace/lib/c/arch/mips32eb/include/libarch/istate_struct.h
-uspace/lib/c/arch/mips32/include/libarch/fibril_context.h
-uspace/lib/c/arch/mips32/include/libarch/istate_struct.h
-uspace/lib/c/arch/ia64/include/libarch/fibril_context.h
-uspace/lib/c/arch/ia64/include/libarch/istate_struct.h
Index: abi/include/abi/ddi/arg.h
===================================================================
--- abi/include/abi/ddi/arg.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ abi/include/abi/ddi/arg.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,6 @@
 #define ABI_DDI_ARG_H_
 
+#include <stdint.h>
+
 #define DMAMEM_FLAGS_ANONYMOUS  0x01
 
Index: abi/include/abi/ddi/irq.h
===================================================================
--- abi/include/abi/ddi/irq.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ abi/include/abi/ddi/irq.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,4 +35,6 @@
 #ifndef ABI_DDI_IRQ_H_
 #define ABI_DDI_IRQ_H_
+
+#include <stdint.h>
 
 typedef struct {
Index: abi/include/abi/elf.h
===================================================================
--- abi/include/abi/elf.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ abi/include/abi/elf.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,4 +35,6 @@
 #ifndef ABI_ELF_H_
 #define ABI_ELF_H_
+
+#include <stdint.h>
 
 /**
Index: abi/include/abi/fourcc.h
===================================================================
--- abi/include/abi/fourcc.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ abi/include/abi/fourcc.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,12 +36,12 @@
 #define ABI_FOURCC_H_
 
-#include "../../../common.h"
+#include <stdint.h>
 
 #define FOURCC(a, b, c, d) \
-	(((UINT32_T) (a)) | (((UINT32_T) (b)) << 8) | \
-	    (((UINT32_T) (c)) << 16) | (((UINT32_T) (d)) << 24))
+	(((uint32_t) (a)) | (((uint32_t) (b)) << 8) | \
+	    (((uint32_t) (c)) << 16) | (((uint32_t) (d)) << 24))
 
 #define CC_COMPACT(a) \
-	((UINT32_T) (a) & 0x7f)
+	((uint32_t) (a) & 0x7f)
 
 #define FOURCC_COMPACT(a, b, c, d) \
Index: abi/include/abi/ipc/methods.h
===================================================================
--- abi/include/abi/ipc/methods.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ abi/include/abi/ipc/methods.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -58,26 +58,4 @@
 	 */
 	IPC_M_PHONE_HUNGUP = 0,
-
-	/** Clone connection.
-	 *
-	 * The calling task clones one of its phones for the callee.
-	 *
-	 * - ARG1 - The caller sets ARG1 to the phone of the cloned connection.
-	 *        - The callee gets the new phone from ARG1.
-	 *
-	 * - on answer, the callee acknowledges the new connection by sending EOK back
-	 *   or the kernel closes it
-	 */
-	IPC_M_CONNECTION_CLONE,
-
-	/** Protocol for establishing a cloned connection.
-	 *
-	 * Through this call, the recipient learns about the new cloned connection.
-	 *
-	 * - ARG5 - the kernel sets ARG5 to contain the hash of the used phone
-	 * - on answer, the callee acknowledges the new connection by sending EOK back
-	 *   or the kernel closes it
-	 */
-	IPC_M_CLONE_ESTABLISH,
 
 	/** Protocol for initializing callback connections.
Index: abi/include/abi/proc/task.h
===================================================================
--- abi/include/abi/proc/task.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ abi/include/abi/proc/task.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,6 @@
 #define ABI_PROC_TASK_H_
 
+#include <stdint.h>
+
 typedef uint64_t task_id_t;
 
Index: abi/include/abi/proc/thread.h
===================================================================
--- abi/include/abi/proc/thread.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ abi/include/abi/proc/thread.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,6 @@
 #define ABI_PROC_THREAD_H_
 
+#include <stdint.h>
+
 typedef uint64_t thread_id_t;
 
Index: abi/include/abi/proc/uarg.h
===================================================================
--- abi/include/abi/proc/uarg.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ abi/include/abi/proc/uarg.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,6 @@
 #define ABI_PROC_UARG_H_
 
+#include <stddef.h>
+
 /** Structure passed to uinit kernel thread as argument. */
 typedef struct uspace_arg {
Index: abi/include/abi/syscall.h
===================================================================
--- abi/include/abi/syscall.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ abi/include/abi/syscall.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -78,8 +78,7 @@
 	SYS_IPC_EVENT_UNMASK,
 	
-	SYS_CAP_GRANT,
-	SYS_CAP_REVOKE,
+	SYS_PERM_GRANT,
+	SYS_PERM_REVOKE,
 	
-	SYS_DEVICE_ASSIGN_DEVNO,
 	SYS_PHYSMEM_MAP,
 	SYS_PHYSMEM_UNMAP,
Index: abi/include/abi/sysinfo.h
===================================================================
--- abi/include/abi/sysinfo.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ abi/include/abi/sysinfo.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,6 +37,8 @@
 #define ABI_SYSINFO_H_
 
+#include <abi/bool.h>
 #include <abi/proc/task.h>
 #include <abi/proc/thread.h>
+#include <stdint.h>
 
 /** Number of load components */
Index: boot/Makefile
===================================================================
--- boot/Makefile	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/Makefile	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -27,9 +27,9 @@
 #
 
-.PHONY: all build_dist build_comps clean_dist clean
+.PHONY: all build_dist clean_dist clean
 
 include Makefile.common
 
-all: $(VERSION_DEF) $(COMMON_MAKEFILE) $(COMMON_HEADER) $(CONFIG_MAKEFILE) $(CONFIG_HEADER) $(PREBUILD)
+all: $(VERSION_DEF) $(COMMON_MAKEFILE) $(COMMON_HEADER) $(CONFIG_MAKEFILE) $(CONFIG_HEADER) $(PREBUILD) build_dist
 	$(MAKE) -r -f $(BUILD) PRECHECK=$(PRECHECK)
 ifneq ($(POSTBUILD),)
@@ -37,19 +37,13 @@
 endif
 
-build_comps: $(COMPONENTS) $(LINK).in
-	$(PACK) $(OBJCOPY) $(BFD_NAME) $(BFD_ARCH) arch/$(KARCH) $(COMPONENTS)
-
-$(INITRD).img: build_dist
-ifeq ($(RDFMT),tmpfs)
-	$(MKTMPFS) $(DIST_PATH) $@
-endif
-ifeq ($(RDFMT),fat)
-	$(MKFAT) 1048576 $(DIST_PATH) $@
-endif
-ifeq ($(RDFMT),ext4fs)
-	$(MKEXT4) 1048576 $(DIST_PATH) $@
-endif
-
 build_dist: clean_dist
+	mkdir -p "$(DIST_PATH)/app/"
+	mkdir -p "$(DIST_PATH)/cfg/net/"
+	mkdir -p "$(DIST_PATH)/lib/"
+	mkdir -p "$(DIST_PATH)/loc/"
+	mkdir -p "$(DIST_PATH)/log/"
+	mkdir -p "$(DIST_PATH)/srv/"
+	mkdir -p "$(DIST_PATH)/test/"
+	mkdir -p "$(DIST_PATH)/tmp/"
 	for file in $(RD_SRVS) ; do \
 		cp "$$file" "$(DIST_PATH)/srv/" ; \
@@ -59,5 +53,5 @@
 	done
 ifeq ($(CONFIG_DEVEL_FILES), y)
-	mkdir "$(DIST_PATH)/inc/c/"
+	mkdir -p "$(DIST_PATH)/inc/c/"
 	cp -r -L "$(USPACE_PATH)/lib/c/include/." "$(DIST_PATH)/inc/c/"
 	cp -r -L "$(ROOT_PATH)/abi/include/." "$(DIST_PATH)/inc/c/"
@@ -132,10 +126,9 @@
 	$(MAKE) -r -f $(POSTBUILD) clean PRECHECK=$(PRECHECK)
 endif
-	rm -fr $(SANDBOX)
 	rm -f $(POST_OUTPUT) $(BOOT_OUTPUT) $(DEPEND) $(DEPEND_PREV) arch/*/include/common.h
 	find generic/src/ arch/*/src/ genarch/src/ -name '*.o' -follow -exec rm \{\} \;
 
 clean_dist:
-	rm -f $(INITRD).img $(COMPS_H) $(COMPS_C) $(LINK) $(LINK).comp *.co
+	rm -f $(INITRD).img $(COMPS).s $(COMPS).h $(COMPS)_desc.c $(COMPONENTS_DEFLATE) $(COMPS).o $(COMPS)_desc.o $(COMPS).zip $(LINK)
 	find $(USPACE_PATH)/dist -mindepth 1 -maxdepth 1 -type f -exec rm \{\} \;
 	rm -f $(USPACE_PATH)/dist/srv/*
Index: boot/Makefile.build
===================================================================
--- boot/Makefile.build	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/Makefile.build	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,63 +36,53 @@
 DEFS = -DBOOT -DRELEASE=$(RELEASE) "-DCOPYRIGHT=$(COPYRIGHT)" "-DNAME=$(NAME)" -D__$(BITS)_BITS__ -D__$(ENDIANESS)__
 
+AFLAGS =
 LFLAGS = --fatal-warnings
 
-GCC_CFLAGS = $(INCLUDES) -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
-	-fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) \
-	-finput-charset=UTF-8 -ffreestanding -fno-builtin -nostdlib -nostdinc \
-	-Wall -Wextra -Wno-unused-parameter -Wmissing-prototypes \
+# FIXME: This condition is a workaround for issue #693.
+ifneq ($(BARCH),mips32)
+	AFLAGS += --fatal-warnings
+endif
+
+COMMON_CFLAGS = $(INCLUDES) -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
+	-ffreestanding -fno-builtin -nostdlib -nostdinc \
+	-fexec-charset=UTF-8 -finput-charset=UTF-8
+
+GCC_CFLAGS = -Wall -Wextra -Wno-unused-parameter -Wmissing-prototypes \
 	-std=gnu99 -Werror-implicit-function-declaration -Wwrite-strings \
 	-pipe
 
-ICC_CFLAGS = $(INCLUDES) -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
-	-ffreestanding -fno-builtin -nostdlib -nostdinc -Wall -Wmissing-prototypes \
-	-Werror-implicit-function-declaration -wd170
-
-CLANG_CFLAGS = $(INCLUDES) -O$(OPTIMIZATION) -imacros $(CONFIG_HEADER) \
-	-fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) \
-	-finput-charset=UTF-8 -ffreestanding -fno-builtin -nostdlib -nostdinc \
-	-Wall -Wextra -Wno-unused-parameter -Wmissing-prototypes \
+CLANG_CFLAGS = -Wall -Wextra -Wno-unused-parameter -Wmissing-prototypes \
 	-Werror-implicit-function-declaration -Wwrite-strings \
-	-pipe
+	-pipe  -fno-stack-protector -fno-PIC
 
 ifeq ($(CONFIG_DEBUG),y)
-	GCC_CFLAGS += -Werror
-	ICC_CFLAGS += -Werror
+	COMMON_CFLAGS += -Werror
 endif
 
 ifeq ($(CONFIG_LINE_DEBUG),y)
-	GCC_CFLAGS += -g
-	ICC_CFLAGS += -g
-	CLANG_CFLAGS += -g
+	COMMON_CFLAGS += -g
 endif
 
 ifeq ($(COMPILER),gcc_native)
-	CFLAGS = $(GCC_CFLAGS) $(EXTRA_CFLAGS)
+	CFLAGS = $(COMMON_CFLAGS) $(GCC_CFLAGS) $(EXTRA_CFLAGS)
 	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
 endif
 
 ifeq ($(COMPILER),gcc_cross)
-	CFLAGS = $(GCC_CFLAGS) $(EXTRA_CFLAGS)
+	CFLAGS = $(COMMON_CFLAGS) $(GCC_CFLAGS) $(EXTRA_CFLAGS)
 	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
 endif
 
 ifeq ($(COMPILER),gcc_helenos)
-	CFLAGS = $(GCC_CFLAGS) $(EXTRA_CFLAGS)
-	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
-endif
-
-
-ifeq ($(COMPILER),icc)
-	CFLAGS = $(ICC_CFLAGS) $(EXTRA_CFLAGS)
+	CFLAGS = $(COMMON_CFLAGS) $(GCC_CFLAGS) $(EXTRA_CFLAGS)
 	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
 endif
 
 ifeq ($(COMPILER),clang)
-	CFLAGS = $(CLANG_CFLAGS) $(EXTRA_CFLAGS)
+	CFLAGS = $(COMMON_CFLAGS) $(CLANG_CFLAGS) $(EXTRA_CFLAGS)
 	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
 endif
 
 OBJECTS := $(addsuffix .o,$(basename $(SOURCES)))
-COMPONENT_OBJECTS := $(addsuffix .co,$(basename $(MODULES)))
 
 all: $(VERSION_DEF) $(COMMON_MAKEFILE) $(COMMON_HEADER) $(CONFIG_MAKEFILE) $(CONFIG_HEADER) $(BOOT_OUTPUT)
@@ -102,17 +92,21 @@
 	rm -f $(RAW) $(MAP) $(ARCH_INCLUDE) $(GENARCH_INCLUDE)
 
+ifneq ($(MAKECMDGOALS),clean)
 -include $(DEPEND)
+endif
+
+AS_CFLAGS := $(addprefix -Xassembler ,$(AFLAGS))
 
 $(BOOT_OUTPUT): $(RAW)
 	$(OBJCOPY) -O $(BFD_OUTPUT) $< $@
 
-$(RAW): $(OBJECTS) $(COMPONENT_OBJECTS) $(LINK)
-	$(LD) -n $(LFLAGS) -T $(LINK) -M -Map $(MAP) -o $@ $(COMPONENT_OBJECTS) $(OBJECTS)
+$(RAW): $(OBJECTS) $(LINK)
+	$(LD) -n $(LFLAGS) -T $(LINK) -M -Map $(MAP) -o $@ $(OBJECTS)
 
-$(LINK): $(LINK).comp $(DEPEND)
-	$(GCC) $(DEFS) $(GCC_CFLAGS) -D__ASM__ -D__LINKER__ -E -x c $(LINK).comp | grep -v "^\#" > $(LINK)
+$(LINK): $(DEPEND)
+	$(CC) $(DEFS) $(CFLAGS) -D__ASM__ -D__LINKER__ -E -x c $(LINK).in | grep -v "^\#" > $(LINK)
 
 %.o: %.S $(DEPEND)
-	$(CC) $(DEFS) $(CFLAGS) -D__ASM__ -c $< -o $@
+	$(CC) $(DEFS) $(CFLAGS) $(AS_CFLAGS) -D__ASM__ -c $< -o $@
 ifeq ($(PRECHECK),y)
 	$(JOBFILE) $(JOB) $< $@ as asm/preproc $(DEFS) $(CFLAGS) -D__ASM__
@@ -125,7 +119,30 @@
 endif
 
-$(DEPEND): $(ARCH_INCLUDE) $(GENARCH_INCLUDE) $(COMMON_HEADER_ARCH)
+%.o: %.s $(DEPEND)
+	$(CC) $(DEFS) $(CFLAGS) $(AS_CFLAGS) -D__ASM__ -c $< -o $@
+ifeq ($(PRECHECK),y)
+	$(JOBFILE) $(JOB) $< $@ as asm
+endif
+
+$(DEPEND): $(ARCH_INCLUDE) $(GENARCH_INCLUDE) $(COMMON_HEADER_ARCH) $(PRE_DEPEND)
 	makedepend -f - -- $(DEPEND_DEFS) $(CFLAGS) -- $(SOURCES) > $@ 2> /dev/null
 	-[ -f $(DEPEND_PREV) ] && diff -q $(DEPEND_PREV) $@ && mv -f $(DEPEND_PREV) $@
+
+$(COMPS).s: $(COMPS).zip
+	unzip -p $< $@ > $@
+
+$(COMPS).h: $(COMPS).zip
+	unzip -p $< $@ > $@
+
+$(COMPS)_desc.c: $(COMPS).zip
+	unzip -p $< $@ > $@
+
+$(COMPONENTS_DEFLATE): $(COMPS).zip
+	unzip -p $< $@ > $@
+
+$(COMPS).zip: $(COMPONENTS)
+	$(MKARRAY) --deflate $(COMPS) $(COMP) "$(AS_PROLOG)" ".section .components, \"a\"" $^
+
+include Makefile.initrd
 
 $(ARCH_INCLUDE): arch/$(KARCH)/include/
Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/Makefile.common	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -52,6 +52,5 @@
 DRVS_PATH = drv
 
-SANDBOX = pack
-PACK = $(TOOLS_PATH)/pack.py
+MKARRAY = $(TOOLS_PATH)/mkarray.py
 MKTMPFS = $(TOOLS_PATH)/mktmpfs.py
 MKFAT = $(TOOLS_PATH)/mkfat.py
@@ -183,4 +182,5 @@
 	$(USPACE_PATH)/app/edit/edit \
 	$(USPACE_PATH)/app/fdisk/fdisk \
+	$(USPACE_PATH)/app/gunzip/gunzip \
 	$(USPACE_PATH)/app/inet/inet \
 	$(USPACE_PATH)/app/kill/kill \
@@ -208,4 +208,5 @@
 	$(USPACE_PATH)/app/nterm/nterm \
 	$(USPACE_PATH)/app/ping/ping \
+	$(USPACE_PATH)/app/pkg/pkg \
 	$(USPACE_PATH)/app/stats/stats \
 	$(USPACE_PATH)/app/sysinfo/sysinfo \
@@ -233,8 +234,10 @@
 RD_TESTS = \
 	$(USPACE_PATH)/lib/c/test-libc \
+	$(USPACE_PATH)/lib/label/test-liblabel \
 	$(USPACE_PATH)/lib/posix/test-libposix \
 	$(USPACE_PATH)/lib/uri/test-liburi \
 	$(USPACE_PATH)/drv/bus/usb/xhci/test-xhci \
-	$(USPACE_PATH)/app/bdsh/test-bdsh
+	$(USPACE_PATH)/app/bdsh/test-bdsh \
+	$(USPACE_PATH)/srv/net/tcp/test-tcp
 
 RD_DATA_ESSENTIAL = \
@@ -251,22 +254,24 @@
 	$(INITRD).img
 
+COMPONENTS_DEFLATE := $(addsuffix .deflate,$(notdir $(COMPONENTS)))
+
 LINK = arch/$(BARCH)/_link.ld
-COMPS_H = arch/$(BARCH)/include/_components.h
-COMPS_C = arch/$(BARCH)/src/_components.c
+COMP = component
+COMPS = $(COMP)s
 
 -include arch/$(BARCH)/Makefile.inc
 
 ifeq ($(CONFIG_BAREBONE),y)
-RD_SRVS = $(RD_SRVS_ESSENTIAL)
-RD_APPS = $(RD_APPS_ESSENTIAL)
-RD_DRVS = $(RD_DRVS_ESSENTIAL)
-RD_DRVS_FW = $(RD_DRVS_FW_ESSENTIAL)
-RD_DATA = $(RD_DATA_ESSENTIAL)
+	RD_SRVS = $(RD_SRVS_ESSENTIAL)
+	RD_APPS = $(RD_APPS_ESSENTIAL)
+	RD_DRVS = $(RD_DRVS_ESSENTIAL)
+	RD_DRVS_FW = $(RD_DRVS_FW_ESSENTIAL)
+	RD_DATA = $(RD_DATA_ESSENTIAL)
 else
-RD_SRVS = $(RD_SRVS_ESSENTIAL) $(RD_SRVS_NON_ESSENTIAL)
-RD_APPS = $(RD_APPS_ESSENTIAL) $(RD_APPS_NON_ESSENTIAL)
-RD_DRVS = $(RD_DRVS_ESSENTIAL) $(RD_DRVS_NON_ESSENTIAL)
-RD_DRVS_FW = $(RD_DRVS_FW_ESSENTIAL) $(RD_DRVS_FW_NON_ESSENTIAL)
-RD_DATA = $(RD_DATA_ESSENTIAL) $(RD_DATA_NON_ESSENTIAL)
+	RD_SRVS = $(RD_SRVS_ESSENTIAL) $(RD_SRVS_NON_ESSENTIAL)
+	RD_APPS = $(RD_APPS_ESSENTIAL) $(RD_APPS_NON_ESSENTIAL)
+	RD_DRVS = $(RD_DRVS_ESSENTIAL) $(RD_DRVS_NON_ESSENTIAL)
+	RD_DRVS_FW = $(RD_DRVS_FW_ESSENTIAL) $(RD_DRVS_FW_NON_ESSENTIAL)
+	RD_DATA = $(RD_DATA_ESSENTIAL) $(RD_DATA_NON_ESSENTIAL)
 endif
 
@@ -277,4 +282,3 @@
 JOB ?= image.job
 MAP ?= image.map
-PREBUILD ?= build_comps
 BUILD ?= Makefile.build
Index: boot/Makefile.grub
===================================================================
--- boot/Makefile.grub	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/Makefile.grub	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -57,5 +57,5 @@
 endif
 
-build_dist: clean
+build_dist: clean $(COMPONENTS)
 	mkdir -p $(BOOT)
 	cp -r -L $(GRUB) $(BOOT)/grub
@@ -95,2 +95,4 @@
 clean:
 	rm -fr $(DISTROOT)
+
+include Makefile.initrd
Index: boot/Makefile.initrd
===================================================================
--- boot/Makefile.initrd	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ boot/Makefile.initrd	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,38 @@
+#
+# Copyright (c) 2006 Martin Decky
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+$(INITRD).img:
+ifeq ($(RDFMT),tmpfs)
+	$(MKTMPFS) $(DIST_PATH) $@
+endif
+ifeq ($(RDFMT),fat)
+	$(MKFAT) 1048576 $(DIST_PATH) $@
+endif
+ifeq ($(RDFMT),ext4fs)
+	$(MKEXT4) 1048576 $(DIST_PATH) $@
+endif
Index: boot/arch/amd64/Makefile.inc
===================================================================
--- boot/arch/amd64/Makefile.inc	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/amd64/Makefile.inc	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -71,4 +71,3 @@
 
 BOOT_OUTPUT = $(ROOT_PATH)/image.iso
-PREBUILD = $(INITRD).img
 BUILD = Makefile.grub
Index: boot/arch/arm32/Makefile.inc
===================================================================
--- boot/arch/arm32/Makefile.inc	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/arm32/Makefile.inc	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -45,8 +45,8 @@
 ifeq ($(MACHINE), raspberrypi)
 	BOOT_OUTPUT = image.boot
-	POST_OUTPUT = $(ROOT_PATH)/uImage.bin	
+	POST_OUTPUT = $(ROOT_PATH)/uImage.bin
 	LADDR = 0x00008000
 	SADDR = 0x00008000
-	POSTBUILD = Makefile.uboot	     
+	POSTBUILD = Makefile.uboot
 endif
 
@@ -76,7 +76,6 @@
 		char/atkbd \
 		char/ps2mouse \
+		intctl/icp-ic \
 		platform/icp
-	RD_SRVS_ESSENTIAL += \
-		$(USPACE_PATH)/srv/hw/irc/icp-ic/icp-ic
 endif
 
@@ -96,5 +95,6 @@
 	arch/$(BARCH)/src/mm.c \
 	arch/$(BARCH)/src/putchar.c \
-	$(COMPS_C) \
+	$(COMPS).s \
+	$(COMPS)_desc.c \
 	genarch/src/division.c \
 	generic/src/memstr.c \
@@ -105,2 +105,4 @@
 	generic/src/version.c \
 	generic/src/inflate.c
+
+PRE_DEPEND = $(COMPS).s $(COMPS).h $(COMPS)_desc.c $(COMPONENTS_DEFLATE)
Index: boot/arch/arm32/_link.ld.in
===================================================================
--- boot/arch/arm32/_link.ld.in	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/arm32/_link.ld.in	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -23,5 +23,5 @@
 		*(.bss);        /* uninitialized static variables */
 		*(COMMON);      /* global variables */
-[[COMPONENTS]]
+		*(.components);
 	}
 	bdata_end = .;
Index: boot/arch/arm32/include/mm.h
===================================================================
--- boot/arch/arm32/include/mm.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ boot/arch/arm32/include/mm.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -42,6 +42,4 @@
 #ifndef BOOT_arm32__MM_H
 #define BOOT_arm32__MM_H
-
-#include <typedefs.h>
 
 /** Describe "section" page table entry (one-level paging with 1 MB sized pages). */
